/**
 *
 * un exemple des blocs: try-catch-finally
 * aprs correction de l'exo4!
 *
 * @author Mughal & Rasmussen
 * @author Mohamed Lokbani pour l'emballage!
 *
 * @version 1.1
 */

class A extends Throwable {}

class B extends A {}

public class exo33 {


    public static void f() throws B {
	throw new B();
    }

    public static void main (String [] args) throws A {
	try {
	    f();
	}
	catch (A e) {
	    throw e;
	}
	finally {
	    System.out.println("end!");
	}
    }


}

/*

lokbani>inclure jdk
lokbani>javac exo33.java
lokbani>java exo33

end!
Exception in thread "main" B
        at exo33.f(exo44.java:20)
        at exo33.main(exo44.java:25)

---------------------

catch permet de capturer un objet de type A
donc le throw de la ligne n'a pas t captur d'o le message (ligne 20)

on relance le throw dans le main, pas de catch (niveau suprieur)
d'o le second message (ligne 25). Exception leve mais non capture.


*/
